--
-- chainSaw
-- Specialization for Chain Saw
--
-- by Defender
--

local oldSaveSelectedGame = QuickPlayMenu.saveSelectedGame

QuickPlayMenu.saveSelectedGame = function(self)
  oldSaveSelectedGame(self);
  local treesSaveDir = getUserProfileAppPath() .. "savegame"..gameMenuSystem.quickPlayMenu.selectedIndex;
  local treesSaveXML = treesSaveDir .. "/trees.xml";	
	local existDir = io.open (treesSaveXML, "w");	
	if existDir == nil then
		createXMLFile("createtrees", treesSaveXML, "savetrees");
	end;

  -- save cutted trees
  local treesFile = io.open (treesSaveXML, "w");
  if treesFile ~= nil then
    treesFile:write('<?xml version="1.0" encoding="iso-8859-1" standalone="no" ?>\n');
    treesFile:write('<treesSaves count="'..table.maxn(g_currentMission.urizniteStromy)..'" >\n');
    local a = 0;
    for i=1, table.maxn(g_currentMission.urizniteStromy) do
      local tmp = g_currentMission.urizniteStromy[i];
      if tmp~=nil then
        a = a + 1;
        treesFile:write('  <cuttedTree_'..a..' id="'..tmp..'" />\n');
      end;
    end;
    treesFile:write("</treesSaves>");
    treesFile:close();
  end;	
end;

chainSawPresenter = {};

function chainSawPresenter:loadMap(name)
  self.saws = {};    
end;

function chainSawPresenter:deleteMap()

end;

function chainSawPresenter:mouseEvent(posX, posY, isDown, isUp, button)
end;

function chainSawPresenter:keyEvent(unicode, sym, modifier, isDown)
end;

function chainSawPresenter:update(dt)
end;

function chainSawPresenter:draw()
  for i=1, table.maxn(self.saws) do
    self.saws[i]:draw();
  end;
end;

addModEventListener(chainSawPresenter);

chainSaw = {};

-- Nacteni stromu :)
function projdiObjekt(objekt)
  local o;
  local s;
  local i;
  local t;
  if objekt~=nil then
    s=getName(objekt);    
    if string.find(s,"Tree")~= nil then
      t = {};
      t.node=objekt;
      t.cas=10000;
      table.insert(g_currentMission.stromy,t);      
    else
      for i=0, getNumOfChildren(objekt)-1 do
        o = getChildAt(objekt,i);
        if o~=nil then
          projdiObjekt(o);
        end;
      end;
    end;
  end;
end;

function chainSaw.prerequisitesPresent(specializations)
    return true;
end;

function chainSaw:load(xmlFile)
  
  if g_currentMission.urizniteStromy == nil then
    g_currentMission.urizniteStromy = {};

    local treesSaveDir = getUserProfileAppPath() .. "savegame"..gameMenuSystem.quickPlayMenu.selectedIndex;
    local treesSaveXML = treesSaveDir .. "/trees.xml";	
	  local existDir = io.open (treesSaveXML, "r");	
	  if existDir ~= nil then
		  self.xmlFile = loadXMLFile("TempConfig", treesSaveXML);
		  if self.xmlFile ~= nil then
		    local count = Utils.getNoNil(getXMLFloat(self.xmlFile, "treesSaves#count"),0);
--		    print("Pocet uriznutych stromu "..count);
		    local stromId = 0;
		    for i=1, count do
		      stromId = Utils.getNoNil(getXMLInt(self.xmlFile, "treesSaves.cuttedTree_"..i.."#id"),0);
--		      print("uriznout "..stromId);
		      if stromId>0 then
		        table.insert(g_currentMission.urizniteStromy,stromId);
		        setVisibility(stromId, false);
		        delete(stromId);
		      end;
		    end;
		  end;
	  end;    
  end;

  if g_currentMission.stromy == nil then 
    g_currentMission.stromy = {};
    projdiObjekt(getRootNode());
--    print("Pocet stromu="..table.maxn(g_currentMission.stromy));
  end;
  
	self.getUserInRange = SpecializationUtil.callSpecializationsFunction("getUserInRange");
	
	self.setActiveState = SpecializationUtil.callSpecializationsFunction("setActiveState");
	
	self.typeDesc = Utils.getXMLI18N(xmlFile, "vehicle.typeDesc", "TypeDescription");
	
	self.chainSaw = {};
	self.chainSaw.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.chainSaw#id"));
	self.chainSaw.saw = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.chainSaw#saw"));
  
  local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.chainSaw#sawMinRot"));  
  self.chainSaw.sawMinRot = {};
  self.chainSaw.sawMinRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
  self.chainSaw.sawMinRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
  self.chainSaw.sawMinRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

  x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.chainSaw#sawMaxRot"));
  self.chainSaw.sawMaxRot = {};
  self.chainSaw.sawMaxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
  self.chainSaw.sawMaxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
  self.chainSaw.sawMaxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
		
	x,y,z = getTranslation(self.chainSaw.node);	
	
  self.chainSaw.trans = {x,y,z};
	
	self.isUserInRange = false;
	
	self.isActivated = false;
		
	-- Zvuky
  local IdleSoundFile = Utils.getFilename("nastartovana.ogg", self.baseDirectory);
  self.IdleSoundId = createSample("IdleSound");
  loadSample(self.IdleSoundId, IdleSoundFile, false);
  self.IdlePlaying = false;
  self.IdleRealyPlaying = false;

  local CuttingSoundFile = Utils.getFilename("rezajici.ogg", self.baseDirectory);
  self.CuttingSoundId = createSample("CuttingSound");
  loadSample(self.CuttingSoundId, CuttingSoundFile, false);
  self.CuttingPlaying = false;	
  self.CuttingRealyPlaying = false;
  
  self.config = loadXMLFile("tmpconfig",getUserProfileAppPath().."game.xml");
  local w = getXMLInt(self.config, "game.graphic.display.width");
  local h=getXMLInt(self.config,"game.graphic.display.height");
  self.pomer = (w/h); 

  self.hudInfoBasePosX = 0.6;
  self.hudInfoBaseWidth = 0.2;
  self.hudInfoBaseHeight = self.hudInfoBaseWidth * self.pomer;
  self.hudInfoBasePosY = 1-self.hudInfoBaseHeight;
  self.infoPanelPath = Utils.getFilename("time.png", self.baseDirectory);
	self.hudInfoBaseOverlay = Overlay:new("hudInfoBaseOverlay", self.infoPanelPath, self.hudInfoBasePosX, self.hudInfoBasePosY, self.hudInfoBaseWidth, self.hudInfoBaseHeight);
  self.tme = "";
    
  table.insert(chainSawPresenter.saws,self);
end;

function chainSaw:delete()
  if self.IdleRealyPlaying then
    stopSample(self.IdleSoundId);    
  end;
  if self.CuttingRealyPlaying then
    stopSample(self.CuttingSoundId);
  end;
  delete(self.IdleSoundId);
  delete(self.CuttingSoundId);
  if g_currentMission.stromy ~= nil then
    g_currentMission.stromy = nil; 
  end;
  if g_currentMission.urizniteStromy ~= nil then
    g_currentMission.urizniteStromy = nil;
  end;
   
end;

function chainSaw:mouseEvent(posX, posY, isDown, isUp, button)
end;

function chainSaw:keyEvent(unicode, sym, modifier, isDown)
end;

function chainSaw:update(dt)
	if g_currentMission.currentVehicle == nil then
		self:getUserInRange();

		if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
			if self.isActivated then
				self:setActiveState(false);
			else
				if self.isUserInRange then
					self:setActiveState(true);
				end;
			end;
		end;
		
		if self.isActivated then				
						
			local x,y,z = getRotation(getCamera());
			setRotation(self.chainSaw.node, x,y,z);	
			
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("turn_off_OBJECT"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);

      x, y, z = getRotation(self.chainSaw.saw);
      local rot = {x,y,z};
      local newRot = Utils.getMovedLimitedValues(rot, self.chainSaw.sawMaxRot, self.chainSaw.sawMinRot, 3, 500, dt, not Input.isMouseButtonPressed(Input.MOUSE_BUTTON_LEFT));   
      setRotation(self.chainSaw.saw, unpack(newRot));		    
      
		  if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_LEFT) then
		    self.CuttingPlaying = true;
		    self.IdlePlaying = false;
		    local stromIndex = getTreeInRange(self);
		    if (stromIndex ~= nil) and (stromIndex>0) then
		      local strom = g_currentMission.stromy[stromIndex];
		      strom.cas = strom.cas-dt;
		      self.tme = string.format("%d",(strom.cas/1000));
--		      g_currentMission:addExtraPrintText("Cas do uriznuti stromu: "..string.format("%d",(strom.cas/1000)).." sekund");
		      if strom.cas <= 0 then
		        setVisibility(strom.node, false);
            local i3dNode = Utils.loadSharedI3DFile("kmen.i3d", self.baseDirectory);
            local itemNode = getChildAt(i3dNode,0);
            link(getRootNode(),itemNode);
            setTranslation(itemNode,getWorldTranslation(strom.node));
            setRotation(itemNode,0,0,0);
            g_currentMission:addItemToSave(Utils.getFilename("kmen.i3d", self.baseDirectory), itemNode, 0); 
            table.insert(g_currentMission.urizniteStromy ,strom.node);  
		        delete(strom.node);
		        g_currentMission.stromy[stromIndex]=nil;		        
		      end;
		    end;
		  else
		    self.tme = "";
		    self.IdlePlaying = true;
		    self.CuttingPlaying = false;
      end;
		else
      self.IdlePlaying = false;
      self.CuttingPlaying = false; 		
			if self.isUserInRange then
        g_currentMission:addHelpButtonText(string.format(g_i18n:getText("turn_on_OBJECT"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
      end;				
		end;	
	else
    self.IdlePlaying = false;
    self.CuttingPlaying = false; 		
		self.isUserInRange = false;
		self:setActiveState(false);
	end;

  if self.IdlePlaying then
	  if not self.IdleRealyPlaying then
      playSample(self.IdleSoundId, 0, 1, 0);
      self.IdleRealyPlaying = true;
    end;
  else
	  if self.IdleRealyPlaying then
	    stopSample(self.IdleSoundId);
	    self.IdleRealyPlaying=false;
	  end;
	end;
 	if self.CuttingPlaying then
 	  if not self.CuttingRealyPlaying then
	    playSample(self.CuttingSoundId, 0, 1, 0);
	    self.CuttingRealyPlaying = true;
	  end;
	else
	  if self.CuttingRealyPlaying then
	    stopSample(self.CuttingSoundId);
	    self.CuttingRealyPlaying = false;
	  end;
  end;
end;

function chainSaw:draw()
  if (self.isActivated) and (self.tme~="") then
	  self.hudInfoBaseOverlay:render();
	  setTextAlignment(RenderText.ALIGN_CENTER);
	  setTextColor(0,0,0,1);
	  renderText(self.hudInfoBasePosX+(self.hudInfoBaseWidth/2)-0.005, self.hudInfoBasePosY+((self.hudInfoBaseHeight)*0.38)-0.01,0.04, self.tme.." sec" )
	  setTextColor(1,1,1,1);
	  setTextAlignment(RenderText.ALIGN_LEFT);
  end;	
end;

function chainSaw:setActiveState(isActivated)
	if isActivated then
		unlink(self.chainSaw.node);
		link(Player.rootNode, self.chainSaw.node);
		setRotation(self.chainSaw.node, 0,0,0);
		setTranslation(self.chainSaw.node, 0,0,0);
	else
		unlink(self.chainSaw.node);
		link(self.rootNode, self.chainSaw.node);
		setRotation(self.chainSaw.node, {0,0,0});
		setTranslation(self.chainSaw.node, unpack(self.chainSaw.trans));
	end;
	self.isActivated = isActivated;	
end;

function chainSaw:getUserInRange()
	self.isUserInRange = false; 
	local px, py, pz = getWorldTranslation(self.rootNode);
	local vx, vy, vz = getWorldTranslation(Player.rootNode);
	local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
	if distance < 2 then		
		self.isUserInRange = true;
	end; 
end;

function getTreeInRange(self)
	local nearestDistance = 2.0;
	local px, py, pz = getWorldTranslation(Player.rootNode);
	local v;
	local k;
	local index = 0;
	for k = 1,table.maxn(g_currentMission.stromy) do
	  v = g_currentMission.stromy[k];
	  if v ~= nil then
			local vx, vy, vz = getWorldTranslation(v.node);
			local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
			if distance < nearestDistance then
				index = k;
				nearestDistance = distance;
			end; 
		end;
  end;
  return index;
end;
